//****************************************************************************
//	apci33s.pas
//
//	aPCI-P33
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	Date 1999/05/27
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//****************************************************************************

unit apci33s;

interface

uses
	Windows, Messages, SysUtils, Forms, apci33w;

const
	szTitle = 'Sample';
	sz33  = 'aPCI-P33';

type
	TForm1 = class(TForm)
		procedure FormCreate(Sender: TObject);
	private
		procedure ResultMessage(strbuf: String);
		procedure ErrorMessage(wLogSlot: Word);
	public
		{ Public 錾 }
	end;

var
	Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
var
	b:			Byte;
	strbuf:		        String;
	dwDLLVer, dwDriverVer:  DWord;
        bResult:	        Boolean;		// 
	wLogSlot:	        Word;			// ޲̘_ۯĔԍi[
	dwSwVal:	        DWord;			// ۰ذ̒l
	ri:			TAPCI33RESOURCE;	// ؿ
begin
	//---------------------------------------------------------------------------
	// apci33.dll ̎gp錾
	//---------------------------------------------------------------------------
	if Apci33wDllOpen() = False then begin
           ErrorMessage(APCI33_SLOT_AUTO);
	   Exit;			// apci33.dll ۰ނɎs܂
	end;
	//---------------------------------------------------------------------------
	// ްޮݔԍ\
	// aPCI-P33 DLL,ײްްޮݔԍ擾
	//---------------------------------------------------------------------------
	if Apci33wGetVersion(dwDLLVer, dwDriverVer) = False then begin
	   ErrorMessage(APCI33_SLOT_AUTO);
	   Exit;
	end;

	strbuf := Format('GetVersion'#10 +
	   		 'DLL Version: %08xH'#10 +
	   		 'Vxd Version: %08xH',
	   		 [dwDLLVer, dwDriverVer]);
	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// aPCI-P33̎gp錾
	//---------------------------------------------------------------------------
	wLogSlot := APCI33_SLOT_AUTO;			// gp޲T܂B
	bResult := Apci33wCreate(wLogSlot);		// ꍇA̎޲̘_ۯĔԍi[܂B

	if bResult = False then begin			// ޲܂B
	   ErrorMessage(APCI33_SLOT_AUTO);
	   Exit;
	end;

	strbuf := Format('aPCI-P33 Created'#10#10 +
	   		 'LogSlot: %2d', [wLogSlot]);

	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// ؿ۰ذ̒l擾
	//---------------------------------------------------------------------------
	if Apci33wGetResource(wLogSlot, ri) = False then begin
	   ErrorMessage(wLogSlot);
	   Exit;
	end;

	if Apci33wGetSwitchValue(wLogSlot, dwSwVal) = False then begin
	   ErrorMessage(wLogSlot);
	   Exit;
	end;

	strbuf := Format('Board Name: %s'#10 +
	   		 'NumPorts  : %2d'#10 +
                         'IO Address: %04xH-%04xH'#10 +
			 'Switch    : %04xH',
			 [sz33,
                         ri.dwIOPortLength[2],
                         ri.dwIOPortBase[2],
			 ri.dwIOPortBase[2] + ri.dwIOPortLength[2] - 1,
			 dwSwVal]);

	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// Port 1 ɔCӂްo
	// oް AAh
	//---------------------------------------------------------------------------
	b := Byte($AA);
	if Apci33wOutPort(wLogSlot, APCI33_PORT_1, b) = False then begin
           ErrorMessage(wLogSlot);
	   Exit;
	end;

	strbuf := Format('Port 1 փf[^o'#10 +
	   		 'Port 1 Out Data: %02xH',
	   		 [b]);

	ResultMessage(strbuf);
	//---------------------------------------------------------------------------
	// aPCI-P33̎gpJ
	//---------------------------------------------------------------------------
	if Apci33wClose(wLogSlot) = False then begin
           ErrorMessage(wLogSlot);
	   Exit;
	end;

	ResultMessage('aPCI-P33 Closed');

	// apci33.dll ̎gpJ
	if Apci33wDllClose() = False then begin
	   Application.MessageBox(PChar('DLL ̃A[hɎs܂B'), szTitle, MB_OK + MB_ICONSTOP);
	   Exit;
	end;
end;
//---------------------------------------------------------------------------
// ʂ\
//---------------------------------------------------------------------------
procedure TForm1.ResultMessage(strbuf: String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//---------------------------------------------------------------------------
// װүނ\
//---------------------------------------------------------------------------
procedure TForm1.ErrorMessage(wLogSlot: Word);
var
	dwRes: DWord;
	strbuf: String;
begin
	dwRes := Apci33wGetLastError(wLogSlot);

	case dwRes of
	     APCI33_ERR_SYSTEM:
	     	strbuf := Format('System error'#10#10'Error code: %08xH', [GetLastError()]);
             APCI33_ERR_WRAPDLL:
                strbuf := 'DLL Load error';
        else
		strbuf := Format('aPCI-P33 error'#10#10'Error code: %08xH',[dwRes]);
        end;

	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;

end.

