//============================================================================
//	apci33w.c
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	V1.00 Date 1999/06/03
//
//============================================================================
#include <windows.h>
#include <tchar.h>
#include "apci33w.h"	// aPCI-P33

//-------------------------------------
// (STATIC)ϐȂ
//-------------------------------------
static BOOL Apci33wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL ߰Ċ֐ڽ̊i[ϐ
static FARPROC pApci33GetVersion = NULL;
static FARPROC pApci33Create = NULL;
static FARPROC pApci33Close = NULL;
static FARPROC pApci33GetResource = NULL;
static FARPROC pApci33OutPort = NULL;
static FARPROC pApci33GetLastError = NULL;
static FARPROC pApci33GetSwitchValue = NULL;

//============================================================================
// 	  apci33.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci33wDllOpen()
{
	BOOL	Result = FALSE;
	if (hDLL == NULL){
		hDLL = (HMODULE)LoadLibrary(APCI33_DLL_NAME);
		if (hDLL != NULL){
			Result = Apci33wGetDllExportFunc();
			if (TRUE != Result)
				Apci33wDllClose();	// DLL֐擾ɎŝDLL۰
		}
	}
	return Result;
}
//============================================================================
// 	  apci33.dll۰(۰ގʹװƂ)
// 	  
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci33wDllClose()
{
	BOOL	Result = FALSE;
	if (hDLL != NULL){
		Result = FreeLibrary(hDLL);
		if (TRUE == Result)
			hDLL = NULL;
	}
	return Result;
}
//============================================================================
// 	  aPCI-P33 DLL,޲ײްްޮݔԍ擾
// 	  pdwDllVersion		DLLްޮݔԍi[̈ւ߲
//		  pdwDriverVersion	޲ײްްޮݔԍi[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci33wGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci33GetVersion)(pdwDllVersion, pdwDriverVersion);
	return Result;
}
//============================================================================
// 	  aPCI-P33̔Cӂ޲̎gp錾
// 	  pwLogSlot	 gp޲̘_ۯĔԍi[߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci33wCreate(PWORD pwLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci33Create)(pwLogSlot);
	return Result;
}
//============================================================================
// 	  aPCI-P33̔Cӂ޲̎gpJ
// 	  wLogSlot ޲̘_ۯĔԍ
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci33wClose(WORD wLogSlot)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci33Close)(wLogSlot);
	return Result;
}
//============================================================================
// 	  w޲ؿ擾
// 	  wLogSlot	ؿ擾޲̘_ۯĔԍ
//		  pResInfo	ؿi[\߲̂
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci33wGetResource(WORD wLogSlot, PAPCI33R pResInfo)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci33GetResource)(wLogSlot, pResInfo);
	return Result;
}
//============================================================================
// 	  Cӂ߰Ăްo
// 	  wLogSlot	o͂޲̘_ۯĔԍ
//		  dwLogPort	o͂_߰
//		  bOutValue o͂ް
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci33wOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci33OutPort)(wLogSlot, dwLogPort, bOutValue);
	return Result;
}
//============================================================================
// 	  aPCI-P33̴װ
// 	  wLogSlot	װ޲̘_ۯĔԍ
// ߂l װ
//============================================================================
DWORD Apci33wGetLastError(WORD wLogSlot)
{
	if (hDLL == NULL) {
		return APCI33_ERR_WRAPDLL;
	}
	return (*pApci33GetLastError)(wLogSlot);
}
//============================================================================
// 	  ۰ذ̒l擾
//    wLogSlot			۰ذ̒l擾޲̘_ۯĔԍ
//        pdwSwitchValue	۰ذ̒li[̈ւ߲
// ߂l  TRUE
//		  s FALSE
//============================================================================
BOOL Apci33wGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue)
{
	BOOL	Result = FALSE;
	if (hDLL != NULL)
		Result = (*pApci33GetSwitchValue)(wLogSlot, pdwSwitchValue);
	return Result;
}
//--------------------------------------------------------------------------*/
// 	  DLL߰Ċ֐ڽ̎擾
// 	  
// ߂l  TRUE
//		  s FALSE
//--------------------------------------------------------------------------*/
static BOOL Apci33wGetDllExportFunc()
{
	// Apci33GetVersion ̱ڽ擾
	pApci33GetVersion = GetProcAddress(hDLL, _T("Apci33GetVersion"));
	if (pApci33GetVersion == NULL)
		return FALSE;

	// Apci33Create ̱ڽ擾
	pApci33Create = GetProcAddress(hDLL, _T("Apci33Create"));
	if (pApci33Create == NULL)
		return FALSE;

	// Apci33Close ̱ڽ擾
	pApci33Close = GetProcAddress(hDLL, _T("Apci33Close"));
	if (pApci33Close == NULL)
		return FALSE;

	// Apci33GetResource ̱ڽ擾
	pApci33GetResource = GetProcAddress(hDLL, _T("Apci33GetResource"));
	if (pApci33GetResource == NULL)
		return FALSE;

	// Apci33OutPort ̱ڽ擾
	pApci33OutPort = GetProcAddress(hDLL, _T("Apci33OutPort"));
	if (pApci33OutPort == NULL)
		return FALSE;

	// Apci33GetLastError ̱ڽ擾
	pApci33GetLastError = GetProcAddress(hDLL, _T("Apci33GetLastError"));
	if (pApci33GetLastError == NULL)
		return FALSE;

	// Apci33GetSwitchValue ̱ڽ擾
	pApci33GetSwitchValue = GetProcAddress(hDLL, _T("Apci33GetSwitchValue"));
	if (pApci33GetSwitchValue == NULL)
		return FALSE;

	return TRUE;	// SĂ DLL ߰Ċ֐ڽ擾
}
